/*
Copyright (C) 2000 Evgeniev
TrayPlayer   MCI  (. .   ,    
 .  1.0 alfa  14.02.01

     
 ;      \ 
     GNU, 
"Free Software Foundation" -     2,  ( 
)     .

   ,     
,     ,   
  -     
(. "   GNU").

         "
  GNU";    ,   Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

E-mail: jack@yandex.ru
Web: winapi32.narod.ru
*/

#include <windows.h>
#include <windowsx.h>
#include <Mmsystem.h>
#include <shellapi.h>

#include "c:\lcc\TrayPlayer\trayplayerres.h"

#define MYWM_NOTIFYICON WM_USER+1
#define STOP WM_USER+2
#define PAUSE WM_USER+3
#define PLAY WM_USER+4
#define PRNEXT WM_USER+5
#define NEW WM_USER+6

HWND hwndMain;
HINSTANCE hInst;
NOTIFYICONDATA tnid; //     
HWND hMenu;  //  
HICON hIconStop; //   
HICON hIconPlay; //   play
HICON hIconPause; //   pause

int iControl;  //   (. .   ...

OPENFILENAME ofn;  //     
char cFiles[16384];  //        (.)
char cFullName[32][1024]; //   (  )   
char cCurDir[512];  //    
char cFileName[512]; //    ()
int iPosition;  //   (    cFiles)
int iNumSelected; //   
int iCurNum;

MCI_OPEN_PARMS Open_Params;  //  
MCI_GENERIC_PARMS GenParm;
int DeviceID;


char cInfo[64];

LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
POINT pt;

	switch (msg)
	{

		case MM_MCINOTIFY:
			if(iControl==STOP) break;
			if(iControl==PRNEXT)
				{
					iControl=PLAY;
					break;
				};
			if(iCurNum<iNumSelected)
				{
					iCurNum++;
					mciSendCommand(DeviceID, MCI_CLOSE, 0, (DWORD) &GenParm);
					Open_Params.lpstrDeviceType="WaveAudio";
					Open_Params.lpstrElementName=cFullName[iCurNum];
					if(mciSendCommand(0, MCI_OPEN, MCI_OPEN_ELEMENT, (DWORD)&Open_Params)!=0) break;
					DeviceID=Open_Params.wDeviceID;
					GenParm.dwCallback=(DWORD)hwndMain;
					if(mciSendCommand(DeviceID, MCI_PLAY, MCI_NOTIFY, (DWORD)&GenParm)!=0) break;
					tnid.hIcon = hIconPlay;
					GetFileTitle(cFullName[iCurNum],cInfo,64);
					lstrcpyn(tnid.szTip, cInfo, sizeof(tnid.szTip));
					Shell_NotifyIcon(NIM_MODIFY,&tnid);
				} else
				{
				iControl=STOP;
				tnid.hIcon = hIconStop;
				lstrcpyn(tnid.szTip, "Stop (nothing to play)", sizeof(tnid.szTip));
				Shell_NotifyIcon(NIM_MODIFY,&tnid);
				}
		break;


	case MYWM_NOTIFYICON:
		switch (lParam)
		{
		case WM_RBUTTONDOWN:
			GetCursorPos(&pt);
			SetForegroundWindow(hwndMain);
            TrackPopupMenuEx(hMenu, TPM_HORIZONTAL | TPM_LEFTALIGN, pt.x, pt.y, hwndMain,NULL);
            PostMessage(hwnd, WM_USER, 0, 0);
			break;
		case WM_LBUTTONDOWN:

			if(iControl==PAUSE)
				{
					if(mciSendCommand(DeviceID, MCI_RESUME, 0, (DWORD)&GenParm)!=0) break;
					iControl=PLAY;
					tnid.hIcon = hIconPlay;
					GetFileTitle(cFullName[iCurNum],cInfo,64);
					lstrcpyn(tnid.szTip, cInfo, sizeof(tnid.szTip));
					Shell_NotifyIcon(NIM_MODIFY,&tnid);
					break;
				}
			if(iControl==PLAY)
				{
					if(mciSendCommand(DeviceID, MCI_PAUSE, 0, (DWORD)&GenParm)!=0) break;
					iControl=PAUSE;
					tnid.hIcon = hIconPause;
					lstrcpyn(tnid.szTip, "Pause", sizeof(tnid.szTip));
					Shell_NotifyIcon(NIM_MODIFY,&tnid);
					break;
				}

			Open_Params.lpstrDeviceType="WaveAudio";
			Open_Params.lpstrElementName=cFullName[iCurNum];
			if(mciSendCommand(0, MCI_OPEN, MCI_OPEN_ELEMENT, (DWORD)&Open_Params)!=0) break;
			DeviceID=Open_Params.wDeviceID;
			GenParm.dwCallback=(DWORD)hwndMain;
			if(mciSendCommand(DeviceID, MCI_PLAY, MCI_NOTIFY, (DWORD)&GenParm)!=0) break;
			iControl=PLAY;
			tnid.hIcon = hIconPlay;
			GetFileTitle(cFullName[iCurNum],cInfo,64);
			lstrcpyn(tnid.szTip, cInfo, sizeof(tnid.szTip));
			Shell_NotifyIcon(NIM_MODIFY,&tnid);
			break;



		}
	case WM_COMMAND:
		switch (LOWORD (wParam))
	       	{
				case IDM_ABOUT:
					ShellAbout(0,"TrayPlayer (ver. 1.0a)","E_mail: evasil@nm.ru\nWeb: winapi32.nm.ru",NULL);
				break;

				case IDM_OPEN:
					ofn.lStructSize     = sizeof(OPENFILENAME);
  					ofn.hwndOwner       = hwndMain;
  					ofn.lpstrFilter     = "Audio Files\0*.mp3;*.wma;*.wav\0";
    				ofn.lpstrInitialDir = NULL;
  					ofn.nFilterIndex    = 1;
  					ofn.lpstrFile       = cFiles;
  					ofn.nMaxFile        = sizeof(cFiles);
  					ofn.lpstrFileTitle  = NULL;
  					ofn.nMaxFileTitle   = 512;
					ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_ALLOWMULTISELECT | OFN_EXPLORER;

						if(GetOpenFileName(&ofn))
							{
								iControl=STOP;
								iNumSelected=0;
								iPosition=0;
								mciSendCommand(DeviceID, MCI_CLOSE, 0, (DWORD)&GenParm);
								iCurNum=1;
								tnid.hIcon = hIconStop;
								lstrcpyn(tnid.szTip, "Stop (nothing to play)", sizeof(tnid.szTip));
								Shell_NotifyIcon(NIM_MODIFY,&tnid);

								if(ofn.nFileExtension!=0)
									{
										iNumSelected++;
										wsprintf(cFullName[1],"%s",ofn.lpstrFile);


									} else
										{
											wsprintf(cCurDir,"%s",&cFiles[iPosition]);
											iPosition=iPosition+strlen(cCurDir)+1;
											iCurNum=1;

												do
													{
														iNumSelected++;
														wsprintf(cFileName,"%s",&cFiles[iPosition]);
														iPosition=iPosition+strlen(cFileName)+1;
														wsprintf(cFullName[iNumSelected],"%s\\%s",cCurDir,cFileName);

													}
												while(strlen(cFileName)!=0);
										}

							}
				break;

				case IDM_PREVIOUS:
				if(iCurNum>1)
				{
					iCurNum--;
					mciSendCommand(DeviceID, MCI_CLOSE, 0, (DWORD) &GenParm);
					Open_Params.lpstrDeviceType="WaveAudio";
					Open_Params.lpstrElementName=cFullName[iCurNum];
					if(mciSendCommand(0, MCI_OPEN, MCI_OPEN_ELEMENT, (DWORD)&Open_Params)!=0) break;
					DeviceID=Open_Params.wDeviceID;
					GenParm.dwCallback=(DWORD)hwndMain;
					if(mciSendCommand(DeviceID, MCI_PLAY, MCI_NOTIFY, (DWORD)&GenParm)!=0) break;
					iControl=PLAY;
					tnid.hIcon = hIconPlay;
					GetFileTitle(cFullName[iCurNum],cInfo,64);
					lstrcpyn(tnid.szTip, cInfo, sizeof(tnid.szTip));
					Shell_NotifyIcon(NIM_MODIFY,&tnid);
					iControl=PRNEXT;

				}
				break;

				case IDM_NEXT:
				if(iCurNum<iNumSelected)
				{
					iCurNum++;
					mciSendCommand(DeviceID, MCI_CLOSE, 0, (DWORD) &GenParm);
					Open_Params.lpstrDeviceType="WaveAudio";
					Open_Params.lpstrElementName=cFullName[iCurNum];
					if(mciSendCommand(0, MCI_OPEN, MCI_OPEN_ELEMENT, (DWORD)&Open_Params)!=0) break;
					DeviceID=Open_Params.wDeviceID;
					GenParm.dwCallback=(DWORD)hwndMain;
					if(mciSendCommand(DeviceID, MCI_PLAY, MCI_NOTIFY, (DWORD)&GenParm)!=0) break;
					iControl=PLAY;
					tnid.hIcon = hIconPlay;
					GetFileTitle(cFullName[iCurNum],cInfo,64);
					lstrcpyn(tnid.szTip, cInfo, sizeof(tnid.szTip));
					Shell_NotifyIcon(NIM_MODIFY,&tnid);
					iControl=PRNEXT;
				}
				break;

				case IDM_EXIT:
					Shell_NotifyIcon(NIM_DELETE,&tnid);
					PostQuitMessage(0);
					SendMessage (hwndMain, WM_CLOSE, 0, 0) ;


				break;
			}

		case WM_CREATE:
		hMenu = LoadMenu (hInst,"PopMenu") ;
		hMenu = GetSubMenu (hMenu, 0) ;
		break;

	default:
		return DefWindowProc(hwnd,msg,wParam,lParam);
	}

	return 0;
	}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow)
{
	MSG msg;
	WNDCLASS wc;
	DWORD dwVer;

	memset(&wc,0,sizeof(WNDCLASS));
	wc.lpfnWndProc = (WNDPROC)MainWndProc;
	wc.hInstance = hInstance;
	wc.lpszClassName = "ruslatWndClass";
	RegisterClass(&wc);
		hwndMain=CreateWindow("ruslatWndClass","ruslat",0,
		0,0,0,0,
		NULL,
		NULL,
		hInstance,
		NULL);
		ShowWindow(hwndMain,SW_HIDE);
		hInst=hInstance;

		hIconStop=LoadIcon(hInst,"stopicon");
		hIconPlay=LoadIcon(hInst,"playicon");
		hIconPause=LoadIcon(hInst,"pauseicon");

		tnid.cbSize = sizeof(NOTIFYICONDATA);
		tnid.hWnd = hwndMain;
		tnid.uID = 505;
		tnid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
		tnid.hIcon = hIconStop;
		tnid.uCallbackMessage = MYWM_NOTIFYICON;
		lstrcpyn(tnid.szTip, "Stop (nothing to play)", sizeof(tnid.szTip));
    	Shell_NotifyIcon(NIM_ADD, &tnid);

	while (GetMessage(&msg,NULL,0,0))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

	return msg.wParam;
}


